#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>

#define MAX_NAME 1024
#define BUF_SIZE 10240

void print_prev_seq(char* seq_name, int length, int print_name) {
  if (print_name) printf("%s ", seq_name);
  printf("%d\n", length);
}

int main(int argc, char **argv) {
  FILE *file;
  char seq_name[MAX_NAME] = "";
  char buffer[BUF_SIZE];
  int ch, num_chars, i;
  int get_all = 0;
  int length = 0;
  int name_length = 0;
  int file_param = 1;
  int new_line = 1;
  int header = 0;
  int done = 0;

  if ((argc < 2) || (argc > 3) ||
      ((argc == 3) && (strcmp(argv[1], "-all") != 0)) ||
      ((argc == 2) && (argv[1][0] == '-'))) {
    fprintf(stderr, "Usage:\n\ngetlength [-all] seqfile\n");
    return 1;
  }
  if (argv[1][0] == '-') { get_all = 1; file_param++; }
  file = fopen(argv[file_param], "r");
  if (file == NULL) { perror("error opening seqfile"); return 1; }
  while (!feof(file) && !done) {
    num_chars = fread(buffer, 1, BUF_SIZE, file);
    if ((num_chars < BUF_SIZE) && ferror(file)) {
      perror("error reading seqfile");
      return 1;
    }
    for (i = 0; i < num_chars; i++) {
      ch = buffer[i];
      switch (header) {
        case 0:
          switch (ch) {
            case '\n':
            case '\r':
              new_line = 1;
              break;
            case '>':
              if (new_line) {
	        if (name_length != 0) {
	          print_prev_seq(seq_name, length, get_all);
	          name_length = 0;
                  seq_name[name_length] = '\0';
		  if (!get_all) done = 1;
	        }
	        length = 0;
	        header = 1;
                new_line = 0;
	      }
              break;
            case '.':
            case '-':
              length++;
              new_line = 0;
              break;
            default:
              if (isalpha(ch)) length++;
              new_line = 0;
              break;
          }
          break;
        case 1:
          if (isspace(ch)) {
            switch (ch) {
              case '\n':
              case '\r':
                new_line = 1;
	        header = 0;
                break;
              default:
	        header = 2;
                break;
            }
          } else if (name_length < (MAX_NAME - 1)) {
            seq_name[name_length] = (char)ch;
	    name_length++;
            seq_name[name_length] = '\0';
          } else
	    header = 2;
          break;
        case 2:
          switch (ch) {
            case '\n':
            case '\r':
              new_line = 1;
	      header = 0;
              break;
          }
          break;
      }
      if (done) break;
    }
  }
  fclose (file);
  if (name_length != 0) print_prev_seq(seq_name, length, get_all);
  return 0;
}
